from datetime import datetime

from data.sig_ref import SIGRef
from data.spot import Spot
from providers.spot.http_spot_provider import HTTPSpotProvider


class LLOTA(HTTPSpotProvider):
    """Spot provider for Lagos y Lagunas On the Air"""

    POLL_INTERVAL_SEC = 120
    SPOTS_URL = "https://llota.app/api/public/spots"

    def __init__(self, provider_config):
        super().__init__("LLOTA", provider_config, self.SPOTS_URL, self.POLL_INTERVAL_SEC)

    def _http_response_to_spots(self, http_response):
        new_spots = []
        # Iterate through source data
        for source_spot in http_response.json():
            # Find the most recent spotter and comment from the history array
            comment = None
            spotter = None
            if "history" in source_spot and len(source_spot["history"]) > 0:
                comment = str(source_spot["history"][-1]["comment"])
                spotter = str(source_spot["history"][-1]["spotter_callsign"])
            # Convert to our spot format
            spot = Spot(source=self.name,
                        source_id=source_spot["id"],
                        dx_call=source_spot["callsign"].upper(),
                        de_call=spotter.upper() if spotter else None,
                        freq=float(source_spot["frequency"]) * 1000000,
                        mode=source_spot["mode"].upper(),
                        comment=comment,
                        sig="LLOTA",
                        sig_refs=[SIGRef(id=source_spot["reference"], sig="LLOTA", name=source_spot["reference_name"])],
                        time=datetime.fromisoformat(source_spot["updated_at"].replace("Z", "+00:00")).timestamp())

            # Add to our list. Don't worry about de-duping, removing old spots etc. at this point; other code will do
            # that for us.
            new_spots.append(spot)
        return new_spots
